/**
 * 
 */
package ak.jboss.vault.decrypt;

import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;

import org.jboss.security.plugins.PBEUtils;
import org.picketbox.plugins.vault.PicketBoxSecurityVault;

/**
 * @author a.k.
 */
public class Decryptor {

	public String decrypt(String maskedPsw, String salt, int iterCnt) throws Exception {
		// Extract encrypted password - remove prefix
		int prefixLen = PicketBoxSecurityVault.PASS_MASK_PREFIX.length();
		String encPsw = maskedPsw.substring(prefixLen);

		// Restore the PBE secret key
		String algo = "PBEwithMD5andDES";
		SecretKeyFactory factory = SecretKeyFactory.getInstance(algo);

		char[] password = "somearbitrarycrazystringthatdoesnotmatter".toCharArray();
		PBEParameterSpec cipherSpec = new PBEParameterSpec(salt.getBytes(), iterCnt);
		PBEKeySpec keySpec = new PBEKeySpec(password);
		SecretKey cipherKey = factory.generateSecret(keySpec);

		String psw = PBEUtils.decode64(encPsw, algo, cipherKey, cipherSpec);

		return psw;
	}

}
